#!/usr/local/bin/ruby

include Math
require "Xeg"

ROOT3 = 1.7320508
LIMIT = 8.0

def triangle(x, y, len)
  xl = []
  yl = []

  xtri = [0.0, 1.0, 0.5]
  ytri = [0.0, 0.0, ROOT3 / 2.0]
  color = [0.0, 0.0, 0.0]

  for i in 0..2
	xl[i] = xtri[i] * len + x
	yl[i] = ytri[i] * len + y
  end
  $w.Polygon(xl, yl, 1.0, Xeg::Gr_RGB, color)
  if len > LIMIT
	triangle(x, y, len/2.0)
	triangle(x + len/2.0, y, len/2.0)
	triangle(x + len/4.0, y + ROOT3 * len / 4.0, len/2.0)
  end
end

$w = Xeg::Image.new(100.0, 100.0, 266.0, 256.0)
triangle(5.0, 5.0, 256.0)

gets
