#!/usr/local/bin/ruby

include Math
require "Xeg"

ROOT3 = 1.7320508
LIMIT = 4.0

def triangle(x, y, len, lim, f)
  xl = []
  yl = []

  xtri = [0.25, 0.5, 0.75]
  ytri = [ROOT3 / 4.0, 0.0, ROOT3 / 4.0]
  gray = [0.666666667, 0.0, 0.0]
  color = [0.0, 0.0, 0.0]

  for i in 0..2
	xl[i] = xtri[i] * len + x
	yl[i] = ytri[i] * len + y
  end
  if f == 1
	$w.PolygonFill(xl, yl, Xeg::Gr_MONO, gray)
  end
  $w.Polygon(xl, yl, 0.1, Xeg::Gr_MONO, color)
  if len > LIMIT
	triangle(x, y, len/2.0, lim/4.0, !f)
	triangle(x + len/2.0, y, len/2.0, lim/4.0, !f)
	triangle(x + len/4.0, y + ROOT3 * len / 4.0, len/2.0, lim/2.0, !f)
  end
end

$w = Xeg::Image.new(100.0, 100.0, 266.0, 232.0)
triangle(5.0, 5.0, 256.0, 256.0, 1)

gets
