#!/usr/local/bin/ruby

include Math
require "Xeg"

colors = [
  [1.0, 82.0/256.0, 50.0/256.0],
  [168.0/256.0, 1.0, 58.0/256.0],
  [40.0/256.0, 1.0, 107.0/256.0],
  [56.0/256.0, 164.0/256.0, 1.0],
  [106.0/256.0, 49.0/256.0, 1.0],
  [1.0, 63.0/256.0, 193.0/256.0]]

black = [0.0, 0.0, 0.0]
dgray = [0.3, 0.0, 0.0]
lgray = [0.6, 0.0, 0.0]

msg = "XEasyGraphic"
$w = Xeg::Image.new(50.0, 50.0, 500.0, 500.0)

while 1
  i = 0
  y = 0.0
  while y < 500.0
	$w.BoxFill(0.0, y, 500.0, 86.0, Xeg::Gr_RGB, colors[i])
	i += 1
	y += 86.0
  end
  $w.Text(200.0, 430.0, msg, Xeg::Gr_TD, 36.0, Xeg::Gr_RGB, lgray)
  $w.Text(203.0, 433.0, msg, Xeg::Gr_TD, 36.0, Xeg::Gr_RGB, black)
  x = 0.0; d = 460.0
  while x <= 500.0
	t = -1.0
	while t <= 1.0 && x <= 500.0
	  y = (1.0 - t * t) * d + 10.0
	  $w.CircleFill(x, y, 10.0, Xeg::Gr_RGB, black)
	  $w.CircleFill(x - 3.0, y + 3.0, 4.0, Xeg::Gr_RGB, dgray)
	  $w.CircleFill(x - 4.0, y + 4.0, 2.0, Xeg::Gr_RGB, lgray)
	  x += 5.0
	  t += 0.1
	end
	d -= 50.0
  end
end
