#!/usr/local/bin/ruby

include Math
require "Xeg"

A = 10.0
B = 28.0
C = (8.0 / 3.0)
D = 0.01

$color = [0.0, 0.0, 0.0]

id1 = Xeg::Image.new(40.0, 90.0, 300.0, 300.0)
id2 = Xeg::Image.new(360.0, 90.0, 300.0, 300.0)
id3 = Xeg::Image.new(680.0, 90.0, 300.0, 300.0)

x = 1.0; y = 1.0; z = 1.0
a1 = 0; b1 = 0; c1 = 0

for k in 0..3200
  dx = A * (y - x)
  dy = x * (B - z) - y
  dz = x * y - C * z
  x += D * dx;  y += D * dy;  z += D * dz;
  a2 = (x + 30.0) * 5
  b2 = (y + 30.0) * 5
  c2 = z * 5
  if k > 100
	id1.Line(a1, b1, a2, b2, 0.5, Xeg::Gr_RGB, $color)
	id2.Line(a1, c1, a2, c2, 0.5, Xeg::Gr_RGB, $color)
	id3.Line(b1, c1, b2, c2, 0.5, Xeg::Gr_RGB, $color)
  end
  a1 = a2; b1 = b2; c1 = c2
end
print "End (type Return)"

gets
